local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap_valatea.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_valatea.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_MV_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -6,
	MaxHeight = 120,
	VillagePathList = {
		{
			Entrance = { 728, -2, 1005 },
			Exit = { 334, 0, 957 }
		},
		{
			Entrance = { 79, 2, 964 },
			Exit = { 12, 4, 403 }
		},
		{
			Entrance = { 993, -2, 34 },
			Exit = { 999, -2, 918}
		},
	},
	SpawnList = {
		{-- creating Mineral Deposit 1
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 274, 21, 600 }, Orientation = { 0 , -175, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 2
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 62, 10, 486 }, Orientation = { 0 , 158, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 3
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 47, 8, 482 }, Orientation = { 0 , 122, 0 }, Scale = { 1.7, 1.5, 1 },},
		{-- creating Mineral Deposit 4
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 35, 9, 468 }, Orientation = { 0 , 90, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 5
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 71, 6, 458 }, Orientation = { 0 , 38, 0 }, Scale = { 1.3, 1, 1.3 },},
		{-- creating Mineral Deposit 6
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 100, 43, 583 }, Orientation = { 0 , 145, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 7
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 35, 10, 730 }, Orientation = { 0 , 41, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 8
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 23, 13, 743 }, Orientation = { 0 , 77, 0 }, Scale = { 1.5, 1.3, 1.1 },},		
		{-- creating Mineral Deposit 9
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 34, 9, 760 }, Orientation = { 0 , 112, 0 }, Scale = { 1.6, 1, 1.1 },},
		{-- creating Mineral Deposit 10
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 40, 7, 774 }, Orientation = { 0 , 109, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 11
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 57, 3, 789 }, Orientation = { 0 , 168, 0 }, Scale = { 1.8, 1.2, 1.1 },},
		{-- creating Mineral Deposit 12
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 43, 8, 913 }, Orientation = { 0 , 56, 0 }, Scale = { 1, 1.1, 1.3 },},
		{-- creating Mineral Deposit 13
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 44, 9, 935 }, Orientation = { 0 , 91, 0 }, Scale = { 1.7, 1.4, 1.2 },},
		{-- creating Mineral Deposit 14
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 70, 0, 945 }, Orientation = { 0 , -127, 0 }, Scale = { 1, 1.5, 1.3 },},
		{-- creating Mineral Deposit 15
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 80, 0, 924 }, Orientation = { 0 , -114, 0 }, Scale = { 1.3, 1.5, 1 },},
		{-- creating Mineral Deposit 16
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 40, 5, 960 }, Orientation = { 0 , 102, 0 }, Scale = { 2, 2, 2 },},
		{-- creating Mineral Deposit 17
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 55, 10, 863 }, Orientation = { 0 , 43, 0 }, Scale = { 1.1, 3, 1.1 },},
		{-- creating Mineral Deposit 18
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 130, -1, 1007 }, Orientation = { 0 , 176, 0 }, Scale = { 2.2, 1, 1 },},		
		{-- creating Mineral Deposit 19
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 555, 0, 782 }, Orientation = { 0 , -57, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 20
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 556, -3, 799 }, Orientation = { 0 , -104, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 21
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 530, -4, 784 }, Orientation = { 0 , 23, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 22
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 895, 1, 967 }, Orientation = { 0 , 149, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 23
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 912, 0, 977 }, Orientation = { 0 , 170, 0 }, Scale = { 1.7, 1.3, 1.7 },},
		{-- creating Mineral Deposit 24
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 930, -2, 973 }, Orientation = { 0 , -168, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 25
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 1005, 6, 755 }, Orientation = { 0 , -97, 0 }, Scale = { 1.5, 1, 1.5 },},
		{-- creating Mineral Deposit 26
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 1003, 2, 835 }, Orientation = { 0 , -26, 0 }, Scale = { 1.3, 1.3, 1.3 },},
		{-- creating Mineral Deposit 27
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 985, 3, 476 }, Orientation = { 0 , -147, 0 }, Scale = { 1.1, 1.5, 1.1 },},
		{-- creating Mineral Deposit 28
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 974, 4, 498 }, Orientation = { 0 , -125, 0 }, Scale = { 2, 1.1, 1.2 },},		
		{-- creating Mineral Deposit 29
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 975, -4, 538 }, Orientation = { 0 , -63, 0 }, Scale = { 2, 2.2, 2 },},
		{-- creating Mineral Deposit 30
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 984, 3, 125 }, Orientation = { 0 , -144, 0 }, Scale = { 1.2, 1.2, 1.2 },},
		{-- creating Mineral Deposit 31
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 978, -5, 149 }, Orientation = { 0 , -94, 0 }, Scale = { 2.5, 2.5, 2.5 },},
		{-- creating Mineral Deposit 32
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 968, 2, 176 }, Orientation = { 0 , -80, 0 }, Scale = { 1.4, 1.2, 1 },},
		{-- creating Mineral Deposit 33
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 946, -3, 105 }, Orientation = { 0 , 19, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 34
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 736, 1, 188 }, Orientation = { 0 , -146, 0 }, Scale = { 1.5, 1.2, 1.3 },},
		{-- creating Mineral Deposit 35
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 466, 0, 281 }, Orientation = { 0 , -83, 0 }, Scale = { 1.3, 1, 1.3 },},
		{-- creating Mineral Deposit 36
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 471, -1, 270 }, Orientation = { 0 , 168, 0 }, Scale = { 1.2, 1.3, 1.2 },},
		{-- creating Mineral Deposit 37
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 479, -1, 282 }, Orientation = { 0 , 37, 0 }, Scale = { 1, 1, 1.2 },},
		{-- creating Mineral Deposit 38
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 590, 1, 379 }, Orientation = { 0 , 0, 0 }, Scale = { 0.9, 1.1, 0.9 },},		
		{-- creating Mineral Deposit 38*
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 713, -1, 761 }, Orientation = { 0 , -165, 0 }, Scale = { 1.3, 1, 1.3 },},
		{-- creating Mineral Deposit 39
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 420, 4, 498 }, Orientation = { 0 , 77, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 40
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 425, -7, 483 }, Orientation = { 0 , -126, 0 }, Scale = { 2, 2, 2 },},
		{-- creating Mineral Deposit 41
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 412, 8, 496 }, Orientation = { 0 , -9, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 42
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 437, 4, 480 }, Orientation = { 0 , 33, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 43
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 434, 5, 472 }, Orientation = { 0 , 127, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 44
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 296, -2, 880 }, Orientation = { 0 , -123, 0 }, Scale = { 1.3, 1, 1.3 },},
		{-- creating Mineral Deposit 45
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 306, -4, 875 }, Orientation = { 0 , -169, 0 }, Scale = { 1, 1.3, 1 },},
		{-- creating Mineral Deposit 46
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 366, 1, 737 }, Orientation = { 0 , -52, 0 }, Scale = { 1, 1, 1 },},		
		{-- creating Mineral Deposit 47
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 282, 0, 343 }, Orientation = { 0 , -71, 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 48
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 858, 2, 402 }, Orientation = { 0 , 168, 0 }, Scale = { 2, 1, 1 },},
		{-- creating Mineral Deposit 49
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 588, 2, 1004 }, Orientation = { 0 , 174, 0 }, Scale = { 3, 2, 1.5 },},		
		{-- creating Mineral Deposit 50
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 568, 5, 991 }, Orientation = { 0 , -154, 0 }, Scale = { 1.3, 1, 1.3 },},
		{-- creating Mineral Deposit 51
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 614, 0, 989 }, Orientation = { 0 , -121, 0 }, Scale = { 1.3, 1.3, 0.9 },},
		},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.831, 0.086, 0.682, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 4,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.2
					},
					ColorRange = {
						Min = { 0.917, 0.043, 0.086, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.917, 0.529, 0.043, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.972, 0.925, 0.050, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.25
					},
					ColorRange = {
						Min = { 0.356, 0.454, 0.725, 1 },
						Max = { 0.450, 0.550, 0.800, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 4,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.3
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1.2
					},
					ColorRange = {
						Min = { 0.062, 0.976, 0.537, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.917, 0.721, 0.101, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.729, 0.788, 0.811, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
